<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :filter="filter"
      :pagination.sync="pagination"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="permissions.includes('add_type')"
          >Add Type Game
        </q-btn>
        <div class="col" />
        <div>
          <q-toolbar class="bg-primary text-back rounded-borders">
            <q-input
              dark
              dense
              standout
              v-model="filter"
              input-class="text-right"
              class="q-ml-md"
            >
              <template v-slot:append>
                <q-icon v-if="filter === ''" name="search" />
                <q-icon
                  v-else
                  name="clear"
                  class="cursor-pointer"
                  @click="filter = ''"
                />
              </template>
            </q-input>
          </q-toolbar>
        </div>
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.row.No }}</q-td
        >
        <q-td
          key="group"
          :props="props"
          :style="{ width: '200px', whiteSpace: 'normal' }"
          >{{ props.row.group_name }}</q-td
        >
        <q-td
          key="name"
          :props="props"
          :style="{ width: '500px', whiteSpace: 'normal' }"
          >{{ props.row.name }}</q-td
        >
        <q-td
          key="code"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.code }}</q-td
        >
        <q-td
          key="image"
          :props="props"
          :style="{ width: '200px', whiteSpace: 'normal' }"
        >
          <template>
            <img :src="ConvertImage(props.row.image)" class="image" />
          </template>
        </q-td>
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            @input="ChangeStatus(props.row)"
            v-show="permissions.includes('change_type')"
          />
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-center no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('delete_type')"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="remove(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('delete_type')"
            />
          </div>
        </q-td>
      </q-tr>
    </q-table>
    <!-- add -->
    <q-dialog
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Group" prop="group">
              <q-select
                filled
                label="Select Group"
                v-model="form.group"
                :options="group_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionGroup.includes('view_group')"
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input v-model="form.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImage"
              />
            </el-form-item>
            <el-form-item>
              <img v-bind:src="`data:image/png;base64,${form.image}`" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="permissions.includes('add_type')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Group" prop="group">
              <q-select
                filled
                label="Select Group"
                v-model="form_edit.group"
                :options="group_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionGroup.includes('view_group')"
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_edit.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form_edit.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImageEdit"
              />
            </el-form-item>
            <el-form-item>
              <img :src="ConvertImage(form_edit.image)" class="image" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="Update()"
            v-show="permissions.includes('change_type')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Type",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "group",
          label: "Group",
          field: "group",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "image",
          label: "Image",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: "",
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      modal_edit: false,
      modal_add: false,
      form: { name: "", image: null, code: "" },
      form_edit: {},
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      group_options: [],
      rules: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ],
        group: [
          { required: true, message: "Please Select group", trigger: "change" }
        ]
      },
      permissions:
        this.$q.sessionStorage.getItem("permissions")["type"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["type"]
          : [],
      sessionGroup:
        this.$q.sessionStorage.getItem("permissions")["group"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["group"]
          : [],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ]
    };
  },

  async created() {
    await this.getdata();
    await this.get_group();
  },

  methods: {
    async getdata() {
      try {
        this.data = await this.$services.typegame.read({});
        this.$services.updateindex(this.data);
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    async get_group() {
      let ctx = this;
      this.$services.group
        .read()
        .then(function(data) {
          data.forEach(row => {
            ctx.group_options.push({ value: row.id, label: row.name });
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$router);
        });
    },

    add() {
      this.modal_add = true;
      this.form = { name: "", image: null, code: "" };
    },

    async insert() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.typegame
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$services.success("Save TypeGame Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    load(row) {
      this.form_edit = row;
      this.modal_edit = true;
    },

    async Update() {
      let ctx = this;
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.$services.typegame
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$services.success("Update TypeGame Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Type Game ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          ctx.$services.typegame
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success(
                "Delete Type Game " + row.name + " Success"
              );
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Type Game ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.typegame
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update TypeGame Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
        });
    },

    uploadImage(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form.image = e.target.result.split(",")[1];
      };
    },

    uploadImageEdit(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form_edit.image = e.target.result.split(",")[1];
      };
    },

    ConvertImage(image) {
      if (image != "") {
        if (/(http(s?)):\/\//i.test(image)) {
          return image;
        } else {
          return `data:image/png;base64,${image}`;
        }
      } else {
        return "";
      }
    }
  }
};
</script>

<style lang="stylus"></style>
<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
